/* @lastChanged: "2001-05-29"
 * @filename:    upddsn.c
 * @purpose:     "Updates Registry for ODBC Test"
 * @release:     7.3.0.0
 * @see:         ""
 *
 * @copyright:   "Copyright by SAP AG, 2001"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 */

#include <stdio.h>
#ifdef WIN32
int __stdcall SQLWritePrivateProfileString(char *lpszSection,	char *lpszKey, 
	char *lpszString, char *lpszFile);	
#else
#include "vpr09Config.h"
#endif

int main(int argc, char ** argv)
{
  if ( argc <= 2 ) {
      printf("Usage : upddsn DSN Key [ String ].\n");
	  return(-1);
  }
  else
  {
  	char *lpszDSN, *lpszKey, *lpszString, *p;
	lpszDSN = argv[1];
	lpszKey = argv[2];
	lpszString = argv[3];
	if (lpszDSN) {
	for(;*lpszDSN == '"' || *lpszDSN == ' ';) lpszDSN++;
	for(p=lpszDSN+strlen(lpszDSN)-1;p>lpszDSN && *p == '"' || *p == ' ';p--)
		*p = '\0';
	}
	if (lpszKey) {
	for(;*lpszKey == '"' || *lpszKey == ' ';) lpszKey++;
	for(p=lpszKey+strlen(lpszKey)-1;p>lpszKey && *p == '"' || *p == ' ';p--)
		*p = '\0';
	}
	if (lpszString) {
	for(;*lpszString == '"' || *lpszString == ' ';) lpszString++;
	for(p=lpszString+strlen(lpszString)-1;p>lpszString && *p == '"' || *p == ' ';p--)
		*p = '\0';
	}
#ifdef WIN32
	return(SQLWritePrivateProfileString(lpszDSN, lpszKey, lpszString, "ODBC.INI"));
#else
        {
          tsp00_ErrText ErrText;
          return(pr09ConfigPutString ("odbc.ini", lpszDSN, lpszKey, lpszString, ErrText));
        }
#endif
  }
}
