
#
#    ========== licence begin LGPL
#    Copyright (C) 2002 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#
#system
import sys
import os
import time
import httplib
import urllib
import string
import optlib
import regsub

#usage  : davimport <source dir> <host:port> <target dir>
#default: davimport .webdav  p66796:85 /webdav

def _options ():
     return [
     ('z', 'debug'                 , ':', 'false'                  , 'specifies debug mode'), 
     ('d', 'dbname'                , ':', ''                       , 'specifies dav database'), 
     ('s', 'sourceDir'             , ':', '.\webdav'               , 'specifies source directory'), 
     ('t', 'targetDir'             , ':',  '/webdav'               , 'specifies target directory'),      
     ('h', 'host'                  , ':', 'p66796:85'              , 'specifies dav host        '), 
]

def main (options, args):
    
    options.debug = string.upper(options.debug)

    sourceDir = options.sourceDir
    targetDir = options.targetDir

    try:
       if options.debug == 'TRUE':
          input('\nInit      DAV Service')
       if options.debug == 'FALSE':
          print '\nInit      DAV Service'
          i = 1/0
    except:
       pass 

    cmd = 'net stop  sapdbwww'
    try:
        os.system (cmd)
    except OSError, err:
        print 'command failed:', err 
           
    try:
        os.chdir (os.path.join (os.path.join (os.environ ['INSTROOT'],'pgm')))
    except OSError, err:
        print 'command failed:', err  
       
    cmd = 'wahttp -u'
    try:
        os.system (cmd)
    except OSError, err:
        print 'command failed:', err  
           
    cmd = 'wahttp -i'
    try:
        os.system (cmd)
    except OSError, err:
        print 'command failed:', err  
             
    cmd = 'regedit /s %s' % (os.path.join (os.environ ['JTEST_ROOT'],'loader','python','dav_%s.reg' % options.dbname)) 
    try:
        os.system (cmd)
    except OSError, err:
        print 'command failed:', err         
      
    cmd = 'net start sapdbwww'
    try:
        os.system (cmd)
    except OSError, err:
        print 'command failed:', err 
    
    try:
         if options.debug == 'TRUE':
            input('\nInit      DAV Data')
         if options.debug == 'FALSE':
            print '\nInit      DAV Data'
            i = 1/0
    except:
       pass  

    FileSystemDir(options.host, targetDir, sourceDir)

def FileSystemDir(host, targetDir, sourceDir):
    for file in os.listdir(sourceDir):
        currentPath = os.path.join(sourceDir, file)
        if os.path.isdir(currentPath) == 1:
           WebDAVMkCol(host, targetDir, urllib.quote(file))
           FileSystemDir (host, targetDir + '/' + urllib.quote(file), currentPath)
        else:
           WebDAVPut     (host, targetDir, currentPath)
   
def WebDAVMkCol(host, targetDir, newDir):
    print('MKCOL with http://' + host + targetDir + '/' + newDir)
    h = httplib.HTTP(host)
    h.putrequest('MKCOL', targetDir + '/' + newDir)
    h.putheader ('Host' , host)
    h.endheaders()
    errcode, errmsg, headers = h.getreply()
    if errcode != 201:
       print(errmsg)
       print('<host:port>.......:  ' + host)
       print('<Target Dir>.:  '      + targetDir)
       print('<newDir>..........:  ' + newDir)
       print('\n')

def WebDAVPut(host, targetDir, path):
    myFile = urllib.quote(os.path.basename(path))
    #print('PUT  with http://' + host + targetDir + '/' + myFile)
    input = open(path, 'rb')
    data  = input.read()
    input.close()

    h = httplib.HTTP(host)
    h.putrequest('PUT', targetDir + '/' + myFile)
    h.putheader ('Host', host)
    h.putheader ('Content-Type','text/plain')
    h.putheader ('Content-Length',str(len(data)))
    xml = regsub.split  (myFile,'\.')[1]
    if xml == 'xml':
       h.putheader('SAPDB_DocumentClass','OIM:Catalog')
    h.endheaders()
    h.send(data)
    errcode, errmsg, headers = h.getreply()
    if errcode != 201 and errcode != 204:
       print(errmsg)
       print('<host:port>.......:  ' + host)
       print('<Target Dir>.:  ' + targetDir)
       print('<File>............:  ' + path)
       xml = ''
       
if __name__ == '__main__':
   optlib.optMain2 (main, _options () )


