# @(#) Makefile	6.2	1997-10-10
#
#    ========== licence begin LGPL
#    Copyright (C) 2000 SAP AG
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#    ========== licence end
#


&if $OS=WIN32

CFLAGS = -c -Z7 -Od

LFLAGS = -subsystem:console -entry:mainCRTStartup -nodefaultlib

DFLAGS = -debug -debugtype:cv

&if defined XCOMP
DBROOTORG = $(DBROOT)
DBROOT = $(DBROOT)\cpc_32Bit
SQLLIB = $(DBROOT)\sdk\7403\lib\lib64
&else
SQLLIB = $(DBROOT)/LIB
&endif

all : initu.exe endloss.exe iendlos.exe rendlos.exe checklo.exe omstime.exe

initu.exe : initu.obj $(SQLLIB)
&if defined XCOMP
	$(DBROOT)\bin\cpclnk -BIT64 $(LFLAGS) $(DFLAGS) initu
&else
	cpclnk $(LFLAGS) $(DFLAGS) initu
&endif

endloss.exe : endloss.obj flushbuf.obj $(SQLLIB)
&if defined XCOMP
	$(DBROOT)\bin\cpclnk -BIT64 $(LFLAGS) $(DFLAGS) endloss flushbuf.obj
&else
	cpclnk $(LFLAGS) $(DFLAGS) endloss flushbuf.obj
&endif

iendlos.exe : iendlos.obj flushbuf.obj $(SQLLIB)
&if defined XCOMP
	$(DBROOT)\bin\cpclnk -BIT64 $(LFLAGS) $(DFLAGS) iendlos flushbuf.obj
&else
	cpclnk $(LFLAGS) $(DFLAGS) iendlos flushbuf.obj 
&endif

rendlos.exe : rendlos.obj flushbuf.obj $(SQLLIB)
&if defined XCOMP
	$(DBROOT)\bin\cpclnk -BIT64 $(LFLAGS) $(DFLAGS) rendlos flushbuf.obj
&else
	cpclnk $(LFLAGS) $(DFLAGS) rendlos flushbuf.obj
&endif

checklo.exe : checklo.obj $(SQLLIB)
&if defined XCOMP
	$(DBROOT)\bin\cpclnk -BIT64 $(LFLAGS) $(DFLAGS) checklo
&else
	cpclnk $(LFLAGS) $(DFLAGS) checklo
&endif

omstime.exe : omstime.obj $(SQLLIB)
&if defined XCOMP
	$(DBROOT)\bin\cpclnk -BIT64 $(LFLAGS) $(DFLAGS) omstime
&else
	cpclnk $(LFLAGS) $(DFLAGS) omstime
&endif

initu.obj : initu.cpc     $(DBROOT)/incl/*.h endlos.h
&if defined XCOMP
	$(DBROOT)\bin\cpc -BIT64 -S INTERNAL -H nocheck initu $(CFLAGS)
&else
	cpc -S INTERNAL -H nocheck initu $(CFLAGS)
&endif

endloss.obj : endloss.cpc $(DBROOT)/incl/*.h endlos.h
&if defined XCOMP
	$(DBROOT)\bin\cpc -BIT64 -S INTERNAL -H nocheck endloss $(CFLAGS)
&else
	cpc -S INTERNAL -H nocheck endloss $(CFLAGS)
&endif

iendlos.obj : iendlos.cpc $(DBROOT)/incl/*.h endlos.h
&if defined XCOMP
	$(DBROOT)\bin\cpc -BIT64 -S INTERNAL -H nocheck iendlos $(CFLAGS)
&else
	cpc -S INTERNAL -H nocheck iendlos $(CFLAGS)
&endif

rendlos.obj : rendlos.cpc $(DBROOT)/incl/*.h endlos.h
&if defined XCOMP
	$(DBROOT)\bin\cpc -BIT64 -S INTERNAL -H nocheck rendlos $(CFLAGS)
&else
	cpc -S INTERNAL -H nocheck rendlos $(CFLAGS)
&endif

checklo.obj : checklo.cpc $(DBROOT)/incl/*.h endlos.h
&if defined XCOMP
	$(DBROOT)\bin\cpc -BIT64 -S INTERNAL -H nocheck checklo $(CFLAGS)
&else
	cpc -S INTERNAL -H nocheck checklo $(CFLAGS)
&endif

omstime.obj : omstime.cpc $(DBROOT)/incl/*.h
&if defined XCOMP
	$(DBROOT)\bin\cpc -BIT64 -S sapr3 -H nocheck omstime $(CFLAGS)
&else
	cpc -S sapr3 -H nocheck omstime $(CFLAGS)
&endif

flushbuf.obj : flushbuf.c
	cl  $(CFLAGS) flushbuf.c

clean :
	rm -f initu.exe endloss.exe iendlos.exe rendlos.exe checklo.exe omstime.exe
	rm -f initu.obj endloss.obj iendlos.obj rendlos.obj checklo.obj omstime.exe

&else

all : initu endloss iendlos rendlos checklo omstime

initu : initu.o       $(INSTLIB)/libsqlrte.a
	cpclnk initu

endloss : endloss.o   $(INSTLIB)/libsqlrte.a
	cpclnk endloss

iendlos : iendlos.o   $(INSTLIB)/libsqlrte.a
	cpclnk iendlos

rendlos : rendlos.o   $(INSTLIB)/libsqlrte.a
	cpclnk rendlos

checklo : checklo.o   $(INSTLIB)/libsqlrte.a
	cpclnk checklo

omstime : omstime.o   $(INSTLIB)/libsqlrte.a
	cpclnk omstime

initu.o : initu.cpc     $(DBROOT)/incl endlos.h
	cpc -S INTERNAL -H nocheck initu

endloss.o : endloss.cpc $(DBROOT)/incl endlos.h
	cpc -S INTERNAL -H nocheck endloss

iendlos.o : iendlos.cpc $(DBROOT)/incl endlos.h
	cpc -S INTERNAL -H nocheck iendlos
    
rendlos.o : rendlos.cpc $(DBROOT)/incl endlos.h
	cpc -S INTERNAL -H nocheck rendlos

checklo.o : checklo.cpc $(DBROOT)/incl endlos.h
	cpc -S INTERNAL -H nocheck checklo

omstime.o : omstime.cpc $(DBROOT)/incl endlos.h
	cpc -S sapr3 -H nocheck omstime

clean :
	rm -f initu endloss iendlos rendlos checlo omstime
	rm -f initu.o endloss.o iendlos.o rendlos.o checklo.o omstime.o

$(INSTLIB)/libsqlrte.a :
	echo # to prevent make from trying to use fortran for .f-file

&endif
